<template>
  <el-form ref="formData" :rules="rules" :model="formData" label-width="100px">
    <el-form-item label="路徑" prop="path">
      <el-select v-model="formData.path" style="width:100%;">
        <el-option v-for="(i,index) in path" :key="index" :label="i.PATH" :value="i.ID">
          <span style="float: left">{{ i.TITLE }}</span>
          <span style="float: right; color: #8492a6; font-size: 13px">{{ i.PATH }}</span>
        </el-option>
      </el-select>
    </el-form-item>
    <el-form-item label="功能權限" prop="viewPermission">
      <funcPermission v-model="formData.viewPermission" />
    </el-form-item>
    <el-form-item>
      <el-button type="primary" @click="queryAction">查詢</el-button>
      <el-button v-if="updateShow" type="primary" @click="insertAction">修改</el-button>
      <el-button type="primary" @click="resetAction">重置</el-button>
    </el-form-item>
  </el-form>
</template>
<script>
import {
  getFuncPermission,
  getAllPathAndTitle,
  addFuncAndPathRel,
  query
} from './action'
import { insertFuncPermissionRules } from './rule'
import funcPermission from '@/components/Checkbox/FuncPermission'
export default {
  components: { funcPermission },
  data() {
    return {
      updateShow: false,
      formData: {
        path: '',
        viewPermission: []
      },
      funcPermissList: [],
      path: [],
      rules: insertFuncPermissionRules()
    }
  },
  mounted() {
    this.getAllPathAndTitleAction()
    this.getFuncPermissionAction()
  },
  methods: {
    queryAction: function() {
      query({ path: this.formData.path }).then(res => {
        if (res.status === 'OK') {
          this.formData.viewPermission = res.data
          this.updateShow = true
          alert('查詢成功!')
        } else {
          alert('查詢失敗!')
        }
      })
    },
    resetAction: function() {
      this.$refs['formData'].resetFields()
      this.updateShow = false
    },
    insertAction: function() {
      this.$refs['formData'].validate(valid => {
        if (valid) {
          addFuncAndPathRel(this.formData).then(res => {
            if (res.status === 'OK') {
              alert('修改成功!')
            } else {
              alert('修改失敗!')
            }
          })
        }
      })
    },
    getAllPathAndTitleAction: function() {
      getAllPathAndTitle().then(res => {
        if (res.status === 'OK') {
          this.path = res.data
        }
      })
    },
    getFuncPermissionAction: function() {
      getFuncPermission().then(res => {
        if (res.status === 'OK') {
          this.funcPermissList = res.data
        }
      })
    }
  }
}
</script>
